#include "template-hsc.h"
# 28 "CPUTime.hsc"
#include "HsBase.h"
# 38 "CPUTime.hsc"
#if !defined(mingw32_TARGET_OS) && !defined(cygwin32_TARGET_OS)
# 46 "CPUTime.hsc"
#if defined(HAVE_GETRUSAGE) && ! irix_TARGET_OS && ! solaris2_TARGET_OS
# 63 "CPUTime.hsc"
#else 
# 64 "CPUTime.hsc"
#if defined(HAVE_TIMES)
# 74 "CPUTime.hsc"
#else 
# 79 "CPUTime.hsc"
#endif 
# 80 "CPUTime.hsc"
#endif 
# 82 "CPUTime.hsc"
#else /* win32 */
# 108 "CPUTime.hsc"
#endif /* not _WIN32 */
# 119 "CPUTime.hsc"
#if defined(CLK_TCK)
# 121 "CPUTime.hsc"
#else 
# 124 "CPUTime.hsc"
#endif 

int main (void)
{
#if __GLASGOW_HASKELL__ && __GLASGOW_HASKELL__ < 409
    printf ("{-# OPTIONS -optc-D__GLASGOW_HASKELL__=%d #-}\n", __GLASGOW_HASKELL__);
#endif
    printf ("{-# OPTIONS %s #-}\n", "-#include \"HsBase.h\"");
# 38 "CPUTime.hsc"
#if !defined(mingw32_TARGET_OS) && !defined(cygwin32_TARGET_OS)
# 46 "CPUTime.hsc"
#if defined(HAVE_GETRUSAGE) && ! irix_TARGET_OS && ! solaris2_TARGET_OS
# 63 "CPUTime.hsc"
#else 
# 64 "CPUTime.hsc"
#if defined(HAVE_TIMES)
# 74 "CPUTime.hsc"
#else 
# 79 "CPUTime.hsc"
#endif 
# 80 "CPUTime.hsc"
#endif 
# 82 "CPUTime.hsc"
#else /* win32 */
# 108 "CPUTime.hsc"
#endif /* not _WIN32 */
# 119 "CPUTime.hsc"
#if defined(CLK_TCK)
# 121 "CPUTime.hsc"
#else 
# 124 "CPUTime.hsc"
#endif 
    hsc_line (1, "CPUTime.hsc");
    fputs ("-----------------------------------------------------------------------------\n"
           "", stdout);
    hsc_line (2, "CPUTime.hsc");
    fputs ("-- |\n"
           "-- Module      :  System.CPUTime\n"
           "-- Copyright   :  (c) The University of Glasgow 2001\n"
           "-- License     :  BSD-style (see the file libraries/core/LICENSE)\n"
           "-- \n"
           "-- Maintainer  :  libraries@haskell.org\n"
           "-- Stability   :  provisional\n"
           "-- Portability :  portable\n"
           "--\n"
           "-- The standard CPUTime library.\n"
           "--\n"
           "-----------------------------------------------------------------------------\n"
           "\n"
           "module System.CPUTime \n"
           "\t(\n"
           "         getCPUTime,       -- :: IO Integer\n"
           "\t cpuTimePrecision  -- :: Integer\n"
           "        ) where\n"
           "\n"
           "import Prelude\n"
           "\n"
           "import Foreign\n"
           "import Foreign.C\n"
           "\n"
           "import Data.Ratio\n"
           "\n"
           "", stdout);
    fputs ("\n"
           "", stdout);
    hsc_line (29, "CPUTime.hsc");
    fputs ("\n"
           "-- -----------------------------------------------------------------------------\n"
           "-- |Computation \'getCPUTime\' returns the number of picoseconds CPU time\n"
           "-- used by the current program.  The precision of this result is\n"
           "-- implementation-dependent.\n"
           "\n"
           "getCPUTime :: IO Integer\n"
           "getCPUTime = do\n"
           "\n"
           "", stdout);
# 38 "CPUTime.hsc"
#if !defined(mingw32_TARGET_OS) && !defined(cygwin32_TARGET_OS)
    fputs ("\n"
           "", stdout);
    hsc_line (39, "CPUTime.hsc");
    fputs ("-- getrusage() is right royal pain to deal with when targetting multiple\n"
           "-- versions of Solaris, since some versions supply it in libc (2.3 and 2.5),\n"
           "-- while 2.4 has got it in libucb (I wouldn\'t be too surprised if it was back\n"
           "-- again in libucb in 2.6..)\n"
           "--\n"
           "-- Avoid the problem by resorting to times() instead.\n"
           "--\n"
           "", stdout);
# 46 "CPUTime.hsc"
#if defined(HAVE_GETRUSAGE) && ! irix_TARGET_OS && ! solaris2_TARGET_OS
    fputs ("\n"
           "", stdout);
    hsc_line (47, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 47 "CPUTime.hsc"
    hsc_const (sizeof(struct rusage));
    fputs (") $ \\ p_rusage -> do\n"
           "", stdout);
    hsc_line (48, "CPUTime.hsc");
    fputs ("    getrusage (", stdout);
# 48 "CPUTime.hsc"
    hsc_const (RUSAGE_SELF);
    fputs (") p_rusage\n"
           "", stdout);
    hsc_line (49, "CPUTime.hsc");
    fputs ("\n"
           "    let ru_utime = (", stdout);
# 50 "CPUTime.hsc"
    hsc_ptr (struct rusage, ru_utime);
    fputs (") p_rusage\n"
           "", stdout);
    hsc_line (51, "CPUTime.hsc");
    fputs ("    let ru_stime = (", stdout);
# 51 "CPUTime.hsc"
    hsc_ptr (struct rusage, ru_stime);
    fputs (") p_rusage\n"
           "", stdout);
    hsc_line (52, "CPUTime.hsc");
    fputs ("    u_sec  <- (", stdout);
# 52 "CPUTime.hsc"
    hsc_peek (struct timeval,tv_sec);
    fputs (")  ru_utime :: IO CTime\n"
           "", stdout);
    hsc_line (53, "CPUTime.hsc");
    fputs ("    u_usec <- (", stdout);
# 53 "CPUTime.hsc"
    hsc_peek (struct timeval,tv_usec);
    fputs (") ru_utime :: IO CTime\n"
           "", stdout);
    hsc_line (54, "CPUTime.hsc");
    fputs ("    s_sec  <- (", stdout);
# 54 "CPUTime.hsc"
    hsc_peek (struct timeval,tv_sec);
    fputs (")  ru_stime :: IO CTime\n"
           "", stdout);
    hsc_line (55, "CPUTime.hsc");
    fputs ("    s_usec <- (", stdout);
# 55 "CPUTime.hsc"
    hsc_peek (struct timeval,tv_usec);
    fputs (") ru_stime :: IO CTime\n"
           "", stdout);
    hsc_line (56, "CPUTime.hsc");
    fputs ("\n"
           "    return ((fromIntegral u_sec * 1000000 + fromIntegral u_usec + \n"
           "             fromIntegral s_sec * 1000000 + fromIntegral s_usec) \n"
           "\t\t* 1000000)\n"
           "\n"
           "type CRUsage = ()\n"
           "foreign import ccall unsafe getrusage :: CInt -> Ptr CRUsage -> IO CInt\n"
           "", stdout);
# 63 "CPUTime.hsc"
#else 
    fputs ("\n"
           "", stdout);
    hsc_line (64, "CPUTime.hsc");
    fputs ("", stdout);
# 64 "CPUTime.hsc"
#if defined(HAVE_TIMES)
    fputs ("\n"
           "", stdout);
    hsc_line (65, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 65 "CPUTime.hsc"
    hsc_const (sizeof(struct tms));
    fputs (") $ \\ p_tms -> do\n"
           "", stdout);
    hsc_line (66, "CPUTime.hsc");
    fputs ("    times p_tms\n"
           "    u_ticks  <- (", stdout);
# 67 "CPUTime.hsc"
    hsc_peek (struct tms,tms_utime);
    fputs (") p_tms :: IO CClock\n"
           "", stdout);
    hsc_line (68, "CPUTime.hsc");
    fputs ("    s_ticks  <- (", stdout);
# 68 "CPUTime.hsc"
    hsc_peek (struct tms,tms_stime);
    fputs (") p_tms :: IO CClock\n"
           "", stdout);
    hsc_line (69, "CPUTime.hsc");
    fputs ("    return (( (fromIntegral u_ticks + fromIntegral s_ticks) * 1000000000000) \n"
           "\t\t\t`div` fromIntegral clockTicks)\n"
           "\n"
           "type CTms = ()\n"
           "foreign import ccall unsafe times :: Ptr CTms -> IO CClock\n"
           "", stdout);
# 74 "CPUTime.hsc"
#else 
    fputs ("\n"
           "", stdout);
    hsc_line (75, "CPUTime.hsc");
    fputs ("    ioException (IOError Nothing UnsupportedOperation \n"
           "\t\t\t \"getCPUTime\"\n"
           "\t\t         \"can\'t get CPU time\"\n"
           "\t\t\t Nothing)\n"
           "", stdout);
# 79 "CPUTime.hsc"
#endif 
    fputs ("\n"
           "", stdout);
    hsc_line (80, "CPUTime.hsc");
    fputs ("", stdout);
# 80 "CPUTime.hsc"
#endif 
    fputs ("\n"
           "", stdout);
    hsc_line (81, "CPUTime.hsc");
    fputs ("\n"
           "", stdout);
# 82 "CPUTime.hsc"
#else /* win32 */
    fputs ("\n"
           "", stdout);
    hsc_line (83, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 83 "CPUTime.hsc"
    hsc_const (sizeof(FILETIME));
    fputs (") $ \\ p_creationTime -> do\n"
           "", stdout);
    hsc_line (84, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 84 "CPUTime.hsc"
    hsc_const (sizeof(FILETIME));
    fputs (") $ \\ p_exitTime -> do\n"
           "", stdout);
    hsc_line (85, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 85 "CPUTime.hsc"
    hsc_const (sizeof(FILETIME));
    fputs (") $ \\ p_kernelTime -> do\n"
           "", stdout);
    hsc_line (86, "CPUTime.hsc");
    fputs ("    allocaBytes (", stdout);
# 86 "CPUTime.hsc"
    hsc_const (sizeof(FILETIME));
    fputs (") $ \\ p_userTime -> do\n"
           "", stdout);
    hsc_line (87, "CPUTime.hsc");
    fputs ("    pid <- getCurrentProcess\n"
           "    ok <- getProcessTimes pid p_creationTime p_exitTime p_kernelTime p_userTime\n"
           "    if toBool ok then do\n"
           "      ut <- ft2psecs p_userTime\n"
           "      kt <- ft2psecs p_kernelTime\n"
           "      return (fromIntegral (ut + kt))\n"
           "     else return 0\n"
           "  where ft2psecs ft = do\n"
           "          high <- (", stdout);
# 95 "CPUTime.hsc"
    hsc_peek (FILETIME,dwHighDateTime);
    fputs (") ft :: IO CLong\n"
           "", stdout);
    hsc_line (96, "CPUTime.hsc");
    fputs ("          low <- (", stdout);
# 96 "CPUTime.hsc"
    hsc_peek (FILETIME,dwLowDateTime);
    fputs (") ft :: IO CLong\n"
           "", stdout);
    hsc_line (97, "CPUTime.hsc");
    fputs ("          return (((fromIntegral high) * (2^32) + (fromIntegral low)) * 100000)\n"
           "\n"
           "    -- ToDo: pin down elapsed times to just the OS thread(s) that\n"
           "    -- are evaluating/managing Haskell code.\n"
           "\n"
           "type FILETIME = ()\n"
           "type HANDLE = ()\n"
           "-- need proper Haskell names (initial lower-case character)\n"
           "foreign import ccall unsafe \"GetCurrentProcess\" getCurrentProcess :: IO (Ptr HANDLE)\n"
           "foreign import ccall unsafe \"GetProcessTimes\" getProcessTimes :: Ptr HANDLE -> Ptr FILETIME -> Ptr FILETIME -> Ptr FILETIME -> Ptr FILETIME -> IO CInt\n"
           "\n"
           "", stdout);
# 108 "CPUTime.hsc"
#endif /* not _WIN32 */
    fputs ("\n"
           "", stdout);
    hsc_line (109, "CPUTime.hsc");
    fputs ("\n"
           "-- |The \'cpuTimePrecision\' constant is the smallest measurable difference\n"
           "-- in CPU time that the implementation can record, and is given as an\n"
           "-- integral number of picoseconds.\n"
           "\n"
           "cpuTimePrecision :: Integer\n"
           "cpuTimePrecision = round ((1000000000000::Integer) % fromIntegral (clockTicks))\n"
           "\n"
           "clockTicks :: Int\n"
           "clockTicks =\n"
           "", stdout);
# 119 "CPUTime.hsc"
#if defined(CLK_TCK)
    fputs ("\n"
           "", stdout);
    hsc_line (120, "CPUTime.hsc");
    fputs ("    (", stdout);
# 120 "CPUTime.hsc"
    hsc_const (CLK_TCK);
    fputs (")\n"
           "", stdout);
    hsc_line (121, "CPUTime.hsc");
    fputs ("", stdout);
# 121 "CPUTime.hsc"
#else 
    fputs ("\n"
           "", stdout);
    hsc_line (122, "CPUTime.hsc");
    fputs ("    unsafePerformIO (sysconf (", stdout);
# 122 "CPUTime.hsc"
    hsc_const (_SC_CLK_TCK);
    fputs (") >>= return . fromIntegral)\n"
           "", stdout);
    hsc_line (123, "CPUTime.hsc");
    fputs ("foreign import ccall unsafe sysconf :: CInt -> IO CLong\n"
           "", stdout);
# 124 "CPUTime.hsc"
#endif 
    fputs ("\n"
           "", stdout);
    hsc_line (125, "CPUTime.hsc");
    fputs ("", stdout);
    return 0;
}
